routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('main');
});

Route::get('/member/login', [ MemberController::class, 'login' ] );

Route::get('/member/register', [ MemberController::class, 'register' ] );

Route::get('/member', [ MemberController::class, 'index' ]);

Route::get('/member/profile', [ MemberController::class, 'profile' ]);

Route::get('/dashboard', [ 
	MemberController::class,
	'index'])
	->name('dashbaord')
	->middleware(['auth']);


Route::middleware(['auth', 'can:is-admin'])->group(function(){

	Route::resource('admin/user', UserController::class);
	Route::resource('admin/role', RoleController::class);
	Route::resource('admin/plan', PlanController::class);
	
});

Route::get('/signup', [ SignUpController::class, 'index' ]);
Route::get('/signup/review/{id}', [ SignUpController::class, 'review' ]);
Route::post('/signup/go/{payment_gateway}', [ SignUpController::class, 'go' ])->name('signup.go');

Route::post('/signup/thankyou/{payment_gateway}', [ SignUpController::class, 'thankyou' ])->name('signup.thankyou');
Route::get('/signup/thankyou/{payment_gateway}', [ SignUpController::class, 'thankyou' ]);

app/Models/Role.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Role extends Model
{
    use HasFactory;

    protected $fillable = [
        'name'
    ];

}

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use App\Models\Role;
use Illuminate\Http\Request;

class RoleController extends Controller
{

    public function __construct() {
    }
    
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {   
        $roles = Role::all();
        return view('admin.role.index',[ 'roles' => $roles ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.role.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $data = $request->validate([
            'name' => 'required|min:5|max:100'
        ]);

        $role = Role::create($data);

        return redirect('/admin/role')->with('success',"Peranan <b>{$role->name} ({$role->id})</b> telah berjaya disimpan.");
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        //
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $role = Role::find($id);
        $role->delete();    

        return redirect('/admin/role')->with('success',"Peranan <b>{$role->name} ({$role->id})</b> telah berjaya dipadam.");

    }
}

resources/views/admin/role/create.blade.php
@extends('layout.private') 

@section('content')

    <h1 class="h3 mb-3 text-gray-800">Tambah Peranan Baru</h1>

    <div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">Berikan nama untuk peranan baru</h6>
    </div>
    <div class="card-body">

        <form action="{{ route('role.store') }}" method="post">
            @csrf

            <div class="mb-3 row">
                <label class="col-sm-2 col-form-label">Nama</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control @error('name') is-invalid @enderror" name="name" value="{{ old( 'name' ) }}">
                    @error('name')
                    <div class="invalid-feedback">{{$message}}</div>
                    @enderror
                </div>
            </div>


            <a href="/admin/role" class="btn btn-secondary btn-lg">Batal</a>

            <button type="submit" class="btn btn-lg btn-primary">Simpan</button>

        </form>

    </div>
</div>

@endsection 

resources/views/admin/role/index.blade.php
@extends('layout.private')


@section('content')
<div class="d-flex justify-content-between mb-3">
    <h1 class="h3 mb-2 text-gray-800">Senarai Peranan Pengguna</h1>

    <a href="/admin/role/create" class="btn btn-secondary">Tambah Peranan</a>
</div>


@if( session('success') ) 
    <div class="alert alert-success">{!! session('success') !!}</div>
@endif

<div class="card shadow mb-4">
    <div class="card-header py-3">
        <h6 class="m-0 font-weight-bold text-primary">Senarai Peranan Pengguna</h6>
    </div>
    <div class="card-body">
        <table class="table table-stripe">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>NAMA</th>
                    <th></th>
                </tr>
            </thead>
            <tbody>
                @foreach($roles as $role)
                <tr>
                    <td>{{$role->id}}</td>
                    <td>{{$role->name}}</td>
                    <td>
                        <a href="{{ route('role.edit', $role->id) }}" class="btn btn-sm btn-primary">EDIT</a>
                
                        <form method="post" class="d-inline" 
                        action="{{ route('role.destroy', $role->id) }}"
                        onsubmit="return confirm('Are you sure you want to delete {{$role->name}} ({{$role->id}})?');" >
                            @csrf 
                            @method('DELETE')
                            <button type="submit" class="btn btn-danger btn-sm">DELETE</button>
                        </form>
                    </td>
                </tr>
                @endforeach
            </tbody>

        </table>
    </div>
</div>



@endsection 